screen	equ	04000h

spritesize equ 12
sprites:		equ	07000h
blank			equ	sprites+96


	org 08000h
;	ORG 23769
start:
	call prepare_screen

lp1
        call lp4
        jr lp1


lp4:

        ld ix,sprites

	ld b,4
lp4a:
     	push bc

	call DrawSprite


	ld a,(ix+2)
	add a,(ix+10)
	cp 240
	jr nz,lp4b

	ld a,(ix+1)	; YPos
	add a,(ix+11)
	ld (ix+1),a
	ld a,(ix+11)
	neg
	ld (ix+11),a

	xor a
	jr lp4c
lp4b
    	cp 0
    	jr nz,lp4c

    	ld a,(ix+1)	; YPos
	add a,(ix+11)
	ld (ix+1),a
	ld a,(ix+11)
	neg
	ld (ix+11),a

    	ld a,240
lp4c
	ld (ix+2),a


	ld a,(ix+1)  	;	Sprite YPos
	sub 6
	ld l,a          ;	l = y1
	add a,12
	ld e,a          ;	e = y2

	ld a,(ix+2)     ;	Sprite XPos
	sub 6
	ld h,a          ;	h = x1
	add a,12
	ld d,a		;	d = y2

	ld a,(playerx)
	ld b,a
	ld a,(playery)
	ld c,a
	
	call colchecker

	cp 1

	call z,loselife

	ld de,Spritesize
	add ix,de

	pop bc
	djnz lp4a

	ld ix,player

	call drawsprite



	;	Handle key presses



   		 ld a,(23560)          ; Get Last key
                CP 'o'
                jr z,mpl
                cp 'p'
                jr z,mpr
                cp ' '
                ret nz

		dec (ix+1)
		ld a,(ix+1)

		cp 8
		ret nz

		jr levelend


          ret

mpl:
	  dec (ix+2)
    	  ret

mpr:
    	  inc (ix+2)

	  ret

levelend:
	 call livesdisplay
	 call screenfx
	 call resetplayer
	 ld hl,sprites+10
	 ld de,spritesize

nextsprite:
	 ld a,0
	 inc a
	 and 3
	 ld (nextsprite+1),a

	 jr z,le2
	 ld b,a
le1:
	 add hl,de
	 djnz le1

le2:
	 ld a,(hl)
	 rla
	 ld (hl),a
	 jr resetplayer


;	Set up the screen to draw the road


screenfx:

	 ld a,50
ll1:
    	 halt

	 dec a
         out (0FEh),a
	 jr nz,ll1

	 ret
	 
loselife:
	 call screenfx

lives:
	 ld a,0
	 dec a

	 ld (lives+1),a

	 jr z,ll2


	 jr resetplayer

ll2

	call screenfx

	xor a
	ld (23560),a

	call resetplayer

	ld hl,blank
	ld (playerold),hl
	jp start

livesdisplay:
level:
         ld a,1
         inc a
         ld (level+1),a
         add a,48
	 rst 16
	 ret

resetplayer:

	 ld a,120
	 ld (playerx),a
	 ld a,168
	 ld (playery),a

	 xor a
	 ld (23560),a

	 ret

COLCHECKER:
	; h=x1 , l=y1 (Rect top left)
	; d=x2 , e=y2 (Rect bottom right)
	; b=x , c=y (x,y point to test)


	ld a,b
	cp h
	ret c
	cp d
	ret nc
	ld a,c
	cp l
	ret c
	cp e
	ret nc

	ld a,1


	ret
	
prepare_screen:
 	ld de,screen+1
	ld hl,screen
	ld bc,6143
	ld (hl),0
	ldir


	xor a
	ld (livesdisplay+1),a


	call livesdisplay

	ld a,3
	ld (lives+1),a

	ld de,attrs
	ld hl,5800h

	ld b,6
psa1:
     	push bc
	ld a,(de)
	inc de
	ld b,a
psa2:
     	ld a,(de)
	ld (hl),a
	inc hl
	djnz psa2

	inc de
	pop bc
	djnz psa1

	;	Draw the lines

	ld de,rows
	ld b,10
ps2:
    	push bc

	;	hl = screen address
	ld a,(de)
	ld l,a
	inc de
	ld a,(de)
	ld h,a
	inc de

	;	b = loop
	ld a,(de)
	inc de
	ld b,a

	;       a = number of times to skip
	ld a,(de)
	
	inc de
ps1:
	ld (hl),%10101010
	
	push bc

	ld b,a
ps3:
    	inc hl
	djnz ps3



	pop bc

	djnz ps1
	

	pop bc
	djnz ps2


	ld de,sprites
	ld hl,SpriteResetData
	ld bc,spritesize*4
	ldir




	call screenfx
	xor a
	ld (23560),a
	ret



DrawSprite:

	;	Byte	Description

	;	0	Sprite id	(0 = sprite disabled)
	;	1	Sprite Status (0 = off, 1 = on, 2 = erase (no drawing))
	;	2	Sprite Colour
	;	3	Sprite Y
	;	4	Sprite X
	;	5	Last X
	;	6,7	Last Screen Address
	;	8,9	Graphic Data Address.
	;	10,11	Last Graphic Address
	;	12	Sprite Height
	;	13	Reserved
	;	14	Reserved

	ld a,(ix+0)
	and a
	ret z

	ld a,(ix+0)		; store colour for later.
	ld (_Sprite_Ink),a


    	ld a,(ix+1)
    	ld (_Sprite_YPos),a
    	ld e,a

	ld d,(ix+2)
	inc l

	ld a,e
	ld (_Sprite_Attr_Height),a

	ld c,(ix+2)	; bc = x
	;ld b,0

	ld a,c
	ld (_Sprite_Attr_Width),a

	ld a,(ix+3)	; a = last x
	ld (ix+3),c
	inc l

	push hl
	push af


 
 	; generate screen address without using tables :-)
	; store result in hl ?

	ld a,e
	srl a
	srl a
	srl a
	and 24
	or 64
	ld h,a
	ld a,e
	and 7
	or h
	ld h,a

	ld a,e
	sla a
	sla a
	and 224
	ld l,a
	ld a,c
	srl a
	srl a
	srl a
	or l
	ld l,a		; at this point hl = screen address.

	  ld (_Sprite_ScreenAddr),hl


	ex de,hl	; store newly calculated screen address in de.

	; ---- Set the attributes (rough experimental version) ----

	push de
	push hl

	; converts a screen address to an attribute address
	; on entry: de = screen address
	; on exit : de = attr address

	ld a,d
	rra
	rra
	rra
	and 3
	or 88
	ld d,a

	ex de,hl

	ld a,(_Sprite_Attr_Width)
	and 7
	jp nz, draw_wide_attr

	ld de,31
	ld a,(_Sprite_Ink)

	CALL INCATTR
	CALL INCATTR

	ld a,(_Sprite_Attr_Height)
	and 7
	jp z, done_draw_attr
	ld a,(_Sprite_Ink)

	ld (hl),a
	inc hl


	ld (hl),a
	jp done_draw_attr

draw_wide_attr:
	ld a,(_Sprite_Ink)
	ld de,30


	CALL INCATTRA


	CALL INCATTRA

	and 7
	jp nz, done_draw_attr
	ld a,(_Sprite_Ink)

	ld (hl),a
	inc hl
	ld (hl),a
	inc hl
	ld (hl),a

done_draw_attr:
	pop hl
	pop de

	; ----- calculate rotate addresses. -----

	ld hl, RotateTable
	ld a,c
	CALL ROTATETHIS
	ld (Sprite_RotateAddr),bc

	pop af
	ld hl, LastRotateTable	;

	CALL ROTATETHIS

	ld (Sprite_LastRotateAddr),bc

	; -----

	pop hl		; hl = last screen address item (in sprite data)

	ld c,(ix+4)	; get last screen address and store new one in its place.
	ld (ix+4),e

	ld b,(ix+5)
	ld (ix+5),d

	ld (_Sprite_LastScreenAddr),bc

	ld e,(ix+6)		; get new graphic address
	ld d,(ix+7)


	ld c,(ix+8)	; get last graphic address and store new one in its place
	ld (ix+8),e
	ld b,(ix+9)
	ld (ix+9),d


	ld (_Sprite_Gfx),de
	ld (_Sprite_Last_Gfx),bc

     ld a,16

	ld (_SpriteLoop),A

		; snippet : load up gfx data.

DrawSpr0:
	ld hl,(_Sprite_Gfx)

		; load up registers with a line of sprite graphic data.

        CALL GFXINC

	ld (_Sprite_Gfx),hl

	ex de,hl	; a,h,l = gfx addr

		; load up alternative registers with a line of sprite graphic data to erase with.

	exx		; load u
	ex af,af'

	ld hl,(_Sprite_Last_Gfx)

	CALL GFXINC


	ld (_Sprite_Last_Gfx),hl
	ex de,hl	; a',h',l' = gfx addr

	exx
	ex af,af'

		; push rotate address onto stack then
		; do ret - cheats way of doing jp (bc)
		; (which doesnt exist..)

	ld bc, EraseRow
	push bc
	ld bc,(Sprite_RotateAddr)
	push bc

	ld de,(_Sprite_ScreenAddr)
	xor a
	ret
EraseRow:
	ld (_Sprite_ScreenAddr),de
	ld bc, NextRow
	push bc
	ld bc,(Sprite_LastRotateAddr)
	push bc
	exx
	ld de,(_Sprite_LastScreenAddr)
	xor a
	ret

NextRow:
	ld (_Sprite_LastScreenAddr),de

	exx
	ld a,(_SpriteLoop)
	dec a
	ld (_SpriteLoop),a
	and a
	jp nz, DrawSpr0
	ret

	; Draw left-rotated line of sprite data.
	; Call with h and l holding the sprite data to display.
	; de = screen address to draw at.
	; a MUST be zero.

Left4:	add hl,hl
	adc a,a
Left3:	add hl,hl
	adc a,a
Left2:	add hl,hl
	adc a,a
Left1:	add hl,hl
	adc a,a

NoRotateLeft:

	ex de,hl

;	ld hl,(_Sprite_ScreenAddr)
    CALL PROCESSSPRITE


    CALL NEXTLINE

nrlend
	ex de,hl
;	ld (_Sprite_ScreenAddr),hl
	ret

	; Draw right-rotated line of sprite data
	; Call with h and l holding the sprite data to display.
	; a MUST be zero.

Right4:
	srl h
	rr l
	rra
Right3:
	srl h
	rr l
	rra
Right2:
	srl h
	rr l
	rra
Right1:
	srl h
	rr l
	rra

NoRotate:
NoRotateRight:

	ex de,hl

	ld b,a	; rotate so order is a,d,e as with left rotate.
	ld a,d
	ld d,e
	ld e,b

;	ld hl,(_Sprite_ScreenAddr)

	CALL PROCESSSPRITE

	CALL NEXTLINE

nrrend
	ex de,hl
;	ld (_Sprite_ScreenAddr),hl
NoRot2:	ret

PROCESSSPRITE:

 push hl

	xor (hl)
	ld (hl),a
	inc l

	; wrap
;	CALL WRAP

	ld a,d
	xor (hl)
	ld (hl),a
	inc l

	; wrap
	;CALL WRAP

	ld a,e
	xor (hl)
	ld (hl),a

    pop hl
    
        RET
        
INCATTRA:
 	ld (hl),a
	inc hl

INCATTR:

	ld (hl),a
	inc hl
	ld (hl),a
	add hl,de
	
	RET
	
GFXINC:

       	ld d,(hl)
	inc hl
	ld e,(hl)
	inc hl

	RET

	
NEXTLINE:

	 inc h
	ld a,h
	and 7
	RET NZ
	ld a,l
	add a,32
	ld l,a
	RET C
	ld a,h
	sub 8
	ld h,a
	
	RET

ROTATETHIS:
	   	and 7
	ld b,0
	ld c,a
	add hl,bc
	add hl,bc
	ld c,(hl)
	inc hl
	ld b,(hl)
	
	RET
rows:
       defw 44A2h
       defb 10,3
       defw 4C02h
       defb 10,3
       defw 4CE2h
       defb 10,3
       defw 5442h
       defb 10,3

       defw 4020h
       defb 32,1
       defw 4740h
       defb 32,1
       
       defw 50A0h
       defb 32,1
       defw 57C0h
       defb 32,1
       
       defw 4860h
       defb 32,1
       defw 4F80h
       defb 32,1

attrs:
       defb 32,%01110111,256,%01000111,256,%01000111,192,%01000111,32,%01110111


RotateTable:
LastRotateTable:

	DEFW NoRotate
	DEFW Right1
	DEFW Right2
	DEFW Right3
	DEFW Left4
	DEFW Left3
	DEFW Left2
	DEFW Left1



	; memory stores to make life easier.

Sprite_RotateAddr:	DEFW	0	; address to 'jump to' to do rotating with
Sprite_LastRotateAddr:	DEFW	NoRot2	; address to 'jump to' to do rotating with

_Sprite_Attr_Width:	DEFB	0	; 0 -> width = 2, otherwise = 3
_Sprite_Attr_Height:	DEFB	0	; 0 -> height= 2 otherwise = 3.

_Sprite_Ink:		DEFB	0
_Sprite_ScreenAddr:	DEFW	0
_Sprite_LastScreenAddr:	DEFW	0
_Sprite_Gfx:		DEFW	0	; address of sprite data
_Sprite_Last_Gfx:	DEFW	0	; address of 'old' sprite data
_SpriteLoop:		DEFB	0	; sprite loop size.
_Sprite_YPos        	DEFB 0
	; ---------------------------------------------------------------
	;		End of Sprite Drawing Routines.
	; ---------------------------------------------------------------

	;	0	Sprite id	(0 = sprite disabled)
	;	1	Sprite Status (0 = off, 1 = on, 2 = erase (no drawing))
	;	2	Sprite Colour
	;	3-4	Sprite Y
	;	5-6	Sprite X
	;	7-8	Last Screen Address
	;	9-10	Graphic Data Address.
	;	11-12	Last Graphic Address
	;	13	Sprite Height
	;	14	Reserved
	;	15	Reserved


Player:
	DEFB	%01000111		; Sprite Colour
PlayerY:	DEFB	168		; Sprite Y
PlayerX:	DEFB	120		; Sprite X
	DEFB	170		; Last X
	DEFW	16384		; Last Screen Address
	DEFW	GFX+64	; Graphic Data Address.
playerold:
	DEFW	blank		; Last Graphic Address
	DEFB	0		; reserved
	DEFB	0
	DEFB	-1		; xdir
	DEFB 	24		; Add on end

SpriteResetData:
	DEFB	65		; Sprite Colour
	DEFB	24		; Sprite Y
	DEFB	40		; Sprite X
	DEFB	40		; Last X
	DEFW	16384		; Last Screen Address
	DEFW	GFX	; Graphic Data Address.
	DEFW	blank		; Last Graphic Address
	DEFB	1		; xdir
	DEFB 	48		; Add on end


	DEFB	66		; Sprite Colour
	DEFB	72		; Sprite Y
	DEFB	160		; Sprite X
	DEFB	20		; Last X
	DEFW	16384		; Last Screen Address
	DEFW	GFX	; Graphic Data Address.
	DEFW	blank		; Last Graphic Address
	DEFB	1		; xdir
	DEFB 	-24		; Add on end


	DEFB	67		; Sprite Colour
	DEFB	104		; Sprite Y
	DEFB	80		; Sprite X
	DEFB	80		; Last X
	DEFW	16384		; Last Screen Address
	DEFW	GFX+32	; Graphic Data Address.
	DEFW	blank		; Last Graphic Address
	DEFB	-1		; xdir
	DEFB 	48		; Add on end


	DEFB	68		; Sprite Colour
	DEFB	128		; Sprite Y
	DEFB	170		; Sprite X
	DEFB	170		; Last X
	DEFW	16384		; Last Screen Address
	DEFW	GFX+32	; Graphic Data Address.
	DEFW	blank		; Last Graphic Address
	DEFB	-1		; xdir
	DEFB 	24		; Add on end




GFX
	  include "gfx.asm"




	end 08000h
;	end 23769